// 

void __stdcall qsort2(int arr[], int lower, int upper)

  {
    int l;
    int r;
    int tmp;

    int pivot = arr[lower];      // Use the first element as the pivot
    /* -----------------------------------------
    Set l and r and move the array elements such
    that for all i:lower<i<l, arr[i]<=pivot,
    and for all i:r<=i<upper, arr[i]>pivot.
    ----------------------------------------- */
    l = lower + 1;
    r = upper;
    while(l < r)
    {
      if (arr[l] <= pivot)
        l++;
      else
      {
        r--;
        tmp = arr[l];
        arr[l] = arr[r];
        arr[r] = tmp;
      }
    }
    l--;
    tmp = arr[lower];
    arr[lower] = arr[l];         // Put pivot element into place
    arr[l] = tmp;
    /* --------------------------------------------------
    Recursively sort the partitions, if their size is > 1
    (if arr partition's size is 1, it is already sorted)
    -------------------------------------------------- */
    if (l-lower > 1)
    qsort2(arr, lower, l);

    if (upper-r > 1)
    qsort2(arr, r, upper);   
  }

// 
